package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.station;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesProductionProcessContextStepService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.util.MesPcnExtConstWords;
import cn.estsh.i3plus.mes.pcn.serviceimpl.fsm.BaseModuleService;
import cn.estsh.i3plus.pojo.base.enumutil.MesPcnEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesStateMachineStatus;
import cn.estsh.i3plus.pojo.mes.model.StationKvBean;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import cn.estsh.i3plus.pojo.mes.model.StationResultBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @Description : 展示组件：非排序生产
 * @Author :wangjie
 **/
@Slf4j
@Service("mesProductionNoSortModuleService")
public class MesProductionNoSortModuleService extends BaseModuleService {

    @Autowired
    private IMesProductionProcessContextStepService productionProcessContextStepService;

    @Override
    public void init(StationRequestBean reqBean) {
        /**
         *  工单号 和  分组
         */
        StationResultBean resultBean = getStationResultBean(reqBean);

        //TODO 获取 头部上下文 信息
//        productionProcessContextStepService.getProductionProcessContext();

        this.sendMessage(reqBean, resultBean);






        this.sendMessage(reqBean, resultBean);

    }

    private StationResultBean getStationResultBean(StationRequestBean reqBean) {
        StationResultBean resultBean = new StationResultBean();
        resultBean.setBusiType(MesPcnEnumUtil.STATION_BUSI_TYPE.MODULE_CONTENT.getValue());
        resultBean.setDataType(MesPcnEnumUtil.STATION_DATA_TYPE.CUSTOM.getValue());
        resultBean.setCustomPageName(MesPcnExtConstWords.CUSTOM_PAGE_NAME_DEFAULT);
        resultBean.setSpecialDisplayData(getStepColIndent(reqBean));

        List<List<StationKvBean>> stationKvBeansList = new ArrayList<>();
        List<StationKvBean> stationKvBeans = new ArrayList<>();
        StationKvBean stationKvBean = new StationKvBean();
        stationKvBean.setKey("orderNo");
        stationKvBean.setName("工单号");
        stationKvBean.setValue("11111");
        stationKvBeans.add(stationKvBean);

        StationKvBean stationKvBean1 = new StationKvBean();
        stationKvBean1.setKey("partNo");
        stationKvBean1.setName("零件号");
        stationKvBean1.setValue("111");
        stationKvBeans.add(stationKvBean1);

        StationKvBean stationKvBean2 = new StationKvBean();
        stationKvBean2.setKey("count");
        stationKvBean2.setName("单数");
        stationKvBean2.setValue("1111");
        stationKvBeans.add(stationKvBean2);

        stationKvBeansList.add(stationKvBeans);
        List<StationKvBean> stationKvBeans1 = new ArrayList<>();
        StationKvBean stationKvBean4 = new StationKvBean();
        stationKvBean4.setKey("orderNo");
        stationKvBean4.setName("工单号");
        stationKvBean4.setValue("11111");
        stationKvBeans1.add(stationKvBean4);

        StationKvBean stationKvBean5 = new StationKvBean();
        stationKvBean5.setKey("partNo");
        stationKvBean5.setName("零件号");
        stationKvBean5.setValue("111");
        stationKvBeans1.add(stationKvBean5);

        StationKvBean stationKvBean6 = new StationKvBean();
        stationKvBean6.setKey("count");
        stationKvBean6.setName("单数");
        stationKvBean6.setValue("1111");
        stationKvBeans1.add(stationKvBean6);
        stationKvBeansList.add(stationKvBeans1);

        List<StationKvBean> stationKvBeans3 = new ArrayList<>();

        StationKvBean stationKvBean7 = new StationKvBean();
        stationKvBean7.setKey("shiftCode");
        stationKvBean7.setName("班次");
        stationKvBean7.setValue("白班");
        stationKvBeans3.add(stationKvBean7);

        StationKvBean stationKvBean8 = new StationKvBean();
        stationKvBean8.setKey("shiftGroup");
        stationKvBean8.setName("班组");
        stationKvBean8.setValue("注塑2班");
        stationKvBeans3.add(stationKvBean8);

        resultBean.setResultObj(stationKvBeans3);
        resultBean.setResultList(stationKvBeansList);
        return resultBean;
    }

    private StationResultBean getStationResultBean1(StationRequestBean reqBean) {
        StationResultBean resultBean = new StationResultBean();
        resultBean.setBusiType(MesPcnEnumUtil.STATION_BUSI_TYPE.MODULE_CUSTOM_CONTENT.getValue());
        resultBean.setDataType(MesPcnEnumUtil.STATION_DATA_TYPE.ECHART.getValue());
        resultBean.setCustomPageName(MesPcnExtConstWords.CUSTOM_PAGE_NAME_DEFAULT);
        resultBean.setSpecialDisplayData(getStepColIndent(reqBean));

        List<List<StationKvBean>> stationKvBeansList = new ArrayList<>();
        List<StationKvBean> stationKvBeans = new ArrayList<>();
        StationKvBean stationKvBean = new StationKvBean();
        stationKvBean.setKey("orderNo");
        stationKvBean.setName("工单号");
        stationKvBean.setValue("11111");
        stationKvBeans.add(stationKvBean);

        StationKvBean stationKvBean1 = new StationKvBean();
        stationKvBean1.setKey("partNo");
        stationKvBean1.setName("零件号");
        stationKvBean1.setValue("111");
        stationKvBeans.add(stationKvBean1);

        StationKvBean stationKvBean2 = new StationKvBean();
        stationKvBean2.setKey("count");
        stationKvBean2.setName("单数");
        stationKvBean2.setValue("1111");
        stationKvBeans.add(stationKvBean2);

        stationKvBeansList.add(stationKvBeans);
        List<StationKvBean> stationKvBeans1 = new ArrayList<>();
        StationKvBean stationKvBean4 = new StationKvBean();
        stationKvBean4.setKey("orderNo");
        stationKvBean4.setName("工单号");
        stationKvBean4.setValue("11111");
        stationKvBeans1.add(stationKvBean4);

        StationKvBean stationKvBean5 = new StationKvBean();
        stationKvBean5.setKey("partNo");
        stationKvBean5.setName("零件号");
        stationKvBean5.setValue("111");
        stationKvBeans1.add(stationKvBean5);

        StationKvBean stationKvBean6 = new StationKvBean();
        stationKvBean6.setKey("count");
        stationKvBean6.setName("单数");
        stationKvBean6.setValue("1111");
        stationKvBeans1.add(stationKvBean6);
        stationKvBeansList.add(stationKvBeans1);

        List<StationKvBean> stationKvBeans3 = new ArrayList<>();

        StationKvBean stationKvBean7 = new StationKvBean();
        stationKvBean7.setKey("shiftCode");
        stationKvBean7.setName("班次");
        stationKvBean7.setValue("白班");
        stationKvBeans3.add(stationKvBean7);

        StationKvBean stationKvBean8 = new StationKvBean();
        stationKvBean8.setKey("shiftGroup");
        stationKvBean8.setName("班组");
        stationKvBean8.setValue("注塑2班");
        stationKvBeans3.add(stationKvBean8);

        resultBean.setResultObj(stationKvBeans3);
        resultBean.setResultList(stationKvBeansList);
        return resultBean;
    }

    @Override
    public boolean execStateModule(StationRequestBean reqBean, List<MesStateMachineStatus> states, Map<String, String> wcpcMap) {
        return true;
    }

}
