package cn.estsh.i3plus.ext.mes.pcn.pojo.context;

import cn.estsh.i3plus.pojo.mes.bean.MesEquipmentLog;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.springframework.beans.BeanUtils;

/**
 * 生产过程上下文对象-数据变量平铺设备LOG信息（兼容扫描信息）
 */
@Data
public class MesEquipVariableCollectContext {

    @ApiParam("组织代码")
    private String organizeCode;

    @ApiParam("设备变量ID")
    private Long equipVariableId;

    @ApiParam("设备ID")
    private Integer equipId;

    @ApiParam("OPC注册ID（设备LOG表的主键）")
    private Integer clientHandle;

    @ApiParam("设备代码")
    private String equipmentCode;

    @ApiParam("通道")
    private String channel;

    @ApiParam("终端")
    private String device;

    @ApiParam("tag名称")
    private String tagName;

    @ApiParam("tag地址")
    private String tagAddress;

    @ApiParam("变量配置类型")
    private String variableCfgType;

    @ApiParam("变量类型")
    private Integer variableType;

    @ApiParam("二级变量")
    private String categoryLevelTwo;

    @ApiParam("数据类型")
    private Integer variableDataType;

    @ApiParam("DB块")
    private String code;

    @ApiParam("轮询时间")
    private Integer scanInterval;

    @ApiParam("读写类型")
    private Integer readWrite;

    @ApiParam("设备变量名称")
    private String equipVariableName;

    @ApiParam("设备变量描述")
    private String equipVariableDesc;

    @ApiParam("读写标记")
    private Integer readWriteFlag;

    @ApiParam("数据类型")
    private String dataType;

    @ApiParam("变量当前值")
    private String equipVariableValue;

    @ApiParam("变量状态")
    private String equipVariableStatus;

    @ApiParam("设备质量")
    private Integer quality;

    @ApiParam("读取时间")
    private String equipVariableReadtime;

    public MesEquipVariableCollectContext() {}

    public MesEquipVariableCollectContext(Long equipVariableId) {
        this.equipVariableId = equipVariableId;
    }

    public MesEquipVariableCollectContext(String organizeCode, String equipVariableValue, String equipVariableReadtime) {
        this.organizeCode = organizeCode;
        this.equipVariableValue = equipVariableValue;
        this.equipVariableReadtime = equipVariableReadtime;
    }

    public void copyValue(MesEquipmentLog equipmentLog, String equipVariableReadtime) {
        if (null == equipmentLog) return;
        BeanUtils.copyProperties(equipmentLog, this);
        this.equipVariableReadtime = equipVariableReadtime;
    }
}
